<template>
  <div>
    <p v-if="this.currentLocation" class="hint">If no coords, using current location
      <br><strong>Lat:</strong> {{ this.currentLocation.lat }}
      <br><strong>Lng:</strong> {{ this.currentLocation.lng }}</p>
    <div class="input-wrapper">
      <label>
        <input
            placeholder="Latitude..."
            type="number"
            v-model="coords.lat"
            @input="onChanged"
        />
      </label>
      <label>
        <input
            placeholder="Longitude..."
            type="number"
            v-model="coords.lng"
            @input="onChanged"
        />
      </label>
    </div>
    <p v-if="error" class="hint error">{{ error }}</p>
  </div>
</template>
<script lang="ts">
// Very basic rebuild of SearchAutocomplete, as really running out of time now :P
import Vue from 'vue';
import { LatLng } from '../../../models/LatLng.model';

export default Vue.extend({
  name: 'LatLngSearch',
  props: {
    trigger: {
      type: Function,
      required: false,
      default: () => null,
    },
    currentLocation: {
      type: LatLng,
      required: false,
    },
  },
  data() {
    return {
      hasValue: false,
      coords: {
        lat: '',
        lng: '',
      },
      error: '',
    };
  },
  methods: {
    onChanged() {
      this.$emit('input', this.coords);
      const cd = new LatLng(parseFloat(this.coords.lat), parseFloat(this.coords.lng));
      if (cd.valid) {
        this.trigger(cd);
        this.error = '';
      } else if (cd.lng || cd.lat) {
        this.error = 'Invalid input';
      } else if (this.error.length > 0) {
        this.trigger(null);
        this.error = '';
      }
    },
  },
});
</script>
<style>

.input-wrapper {
  max-width: 400px;
  margin: auto;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

input[type=number] {
  width: 100%;
  padding: 12px 20px;
  margin: 0 0 10px 0;
  box-sizing: border-box;
  border: 2px solid grey;
  border-radius: 8px;
  font-size: .85rem;
  transition: ease-in-out, width .35s ease-in-out;
}

input[type=number]:focus {
  outline: none;
  border: 2px solid #4AAE9B;
}

.hint {
  font-weight: 600;
  font-size: 0.85rem;
}
.hint.error {
  color: lightcoral;
}
</style>
